1#!/bin/sh
2# Copyright (c) 2007, Nanako Shiraishi
3
4dashless=$(basename "$0" | sed -e 's/-/ /')
5USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
14 [-- <pathspec>...]]
15 or: $dashless clear"
16
17SUBDIRECTORY_OK=Yes
18OPTIONS_SPEC=
19START_DIR=$(pwd)
20. git-sh-setup
21require_work_tree
22prefix=$(git rev-parse --show-prefix) || exit 1
23cd_to_toplevel
24
25TMP="$GIT_DIR/.git-stash.$$"
26TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27trap 'rm -f "$TMP-"* "$TMPindex"' 0
28
29ref_stash=refs/stash
30
31if git config --get-colorbool color.interactive; then
32 help_color="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color="$(git config --get-color '' reset)"
34else
35 help_color=
36 reset_color=
37fi
38
39no_changes () {
40 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41 git diff-files --quiet --ignore-submodules -- "$@" &&
42 (test -z "$untracked" || test -z "$(untracked_files)")
43}
44
45untracked_files () {
46 excl_opt=--exclude-standard
47 test "$untracked" = "all" && excl_opt=
48 git ls-files -o -z $excl_opt -- "$@"
49}
50
51clear_stash () {
52 if test $# != 0
53 then
54 die "$(gettext "git stash clear with parameters is unimplemented")"
55 fi
56 if current=$(git rev-parse --verify --quiet $ref_stash)
57 then
58 git update-ref -d $ref_stash $current
59 fi
60}
61
62create_stash () {
63 stash_msg=
64 untracked=
65 while test $# != 0
66 do
67 case "$1" in
68 -m|--message)
69 shift
70 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
71 ;;
72 -u|--include-untracked)
73 shift
74 untracked=${1?"BUG: create_stash () -u requires an argument"}
75 ;;
76 --)
77 shift
78 break
79 ;;
80 esac
81 shift
82 done
83
84 git update-index -q --refresh
85 if no_changes "$@"
86 then
87 exit 0
88 fi
89
90 # state of the base commit
91 if b_commit=$(git rev-parse --verify HEAD)
92 then
93 head=$(git rev-list --oneline -n 1 HEAD --)
94 else
95 die "$(gettext "You do not have the initial commit yet")"
96 fi
97
98 if branch=$(git symbolic-ref -q HEAD)
99 then
100 branch=${branch#refs/heads/}
101 else
102 branch='(no branch)'
103 fi
104 msg=$(printf '%s: %s' "$branch" "$head")
105
106 # state of the index
107 i_tree=$(git write-tree) &&
108 i_commit=$(printf 'index on %s\n' "$msg" |
109 git commit-tree $i_tree -p $b_commit) ||
110 die "$(gettext "Cannot save the current index state")"
111
112 if test -n "$untracked"
113 then
114 # Untracked files are stored by themselves in a parentless commit, for
115 # ease of unpacking later.
116 u_commit=$(
117 untracked_files "$@" | (
118 GIT_INDEX_FILE="$TMPindex" &&
119 export GIT_INDEX_FILE &&
120 rm -f "$TMPindex" &&
121 git update-index -z --add --remove --stdin &&
122 u_tree=$(git write-tree) &&
123 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
124 rm -f "$TMPindex"
125 ) ) || die "$(gettext "Cannot save the untracked files")"
126
127 untracked_commit_option="-p $u_commit";
128 else
129 untracked_commit_option=
130 fi
131
132 if test -z "$patch_mode"
133 then
134
135 # state of the working tree
136 w_tree=$( (
137 git read-tree --index-output="$TMPindex" -m $i_tree &&
138 GIT_INDEX_FILE="$TMPindex" &&
139 export GIT_INDEX_FILE &&
140 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
141 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
142 git write-tree &&
143 rm -f "$TMPindex"
144 ) ) ||
145 die "$(gettext "Cannot save the current worktree state")"
146
147 else
148
149 rm -f "$TMP-index" &&
150 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
151
152 # find out what the user wants
153 GIT_INDEX_FILE="$TMP-index" \
154 git add--interactive --patch=stash -- "$@" &&
155
156 # state of the working tree
157 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
158 die "$(gettext "Cannot save the current worktree state")"
159
160 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
161 test -s "$TMP-patch" ||
162 die "$(gettext "No changes selected")"
163
164 rm -f "$TMP-index" ||
165 die "$(gettext "Cannot remove temporary index (can't happen)")"
166
167 fi
168
169 # create the stash
170 if test -z "$stash_msg"
171 then
172 stash_msg=$(printf 'WIP on %s' "$msg")
173 else
174 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
175 fi
176 w_commit=$(printf '%s\n' "$stash_msg" |
177 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
178 die "$(gettext "Cannot record working tree state")"
179}
180
181store_stash () {
182 while test $# != 0
183 do
184 case "$1" in
185 -m|--message)
186 shift
187 stash_msg="$1"
188 ;;
189 -q|--quiet)
190 quiet=t
191 ;;
192 *)
193 break
194 ;;
195 esac
196 shift
197 done
198 test $# = 1 ||
199 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
200
201 w_commit="$1"
202 if test -z "$stash_msg"
203 then
204 stash_msg="Created via \"git stash store\"."
205 fi
206
207 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
208 ret=$?
209 test $ret != 0 && test -z "$quiet" &&
210 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
211 return $ret
212}
213
214push_stash () {
215 keep_index=
216 patch_mode=
217 untracked=
218 stash_msg=
219 while test $# != 0
220 do
221 case "$1" in
222 -k|--keep-index)
223 keep_index=t
224 ;;
225 --no-keep-index)
226 keep_index=n
227 ;;
228 -p|--patch)
229 patch_mode=t
230 # only default to keep if we don't already have an override
231 test -z "$keep_index" && keep_index=t
232 ;;
233 -q|--quiet)
234 GIT_QUIET=t
235 ;;
236 -u|--include-untracked)
237 untracked=untracked
238 ;;
239 -a|--all)
240 untracked=all
241 ;;
242 -m|--message)
243 shift
244 test -z ${1+x} && usage
245 stash_msg=$1
246 ;;
247 --help)
248 show_help
249 ;;
250 --)
251 shift
252 break
253 ;;
254 -*)
255 option="$1"
256 # TRANSLATORS: $option is an invalid option, like
257 # `--blah-blah'. The 7 spaces at the beginning of the
258 # second line correspond to "error: ". So you should line
259 # up the second line with however many characters the
260 # translation of "error: " takes in your language. E.g. in
261 # English this is:
262 #
263 # $ git stash save --blah-blah 2>&1 | head -n 2
264 # error: unknown option for 'stash save': --blah-blah
265 # To provide a message, use git stash save -- '--blah-blah'
266 eval_gettextln "error: unknown option for 'stash save': \$option
267 To provide a message, use git stash save -- '\$option'"
268 usage
269 ;;
270 *)
271 break
272 ;;
273 esac
274 shift
275 done
276
277 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
278
279 if test -n "$patch_mode" && test -n "$untracked"
280 then
281 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
282 fi
283
284 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
285
286 git update-index -q --refresh
287 if no_changes "$@"
288 then
289 say "$(gettext "No local changes to save")"
290 exit 0
291 fi
292
293 git reflog exists $ref_stash ||
294 clear_stash || die "$(gettext "Cannot initialize stash")"
295
296 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
297 store_stash -m "$stash_msg" -q $w_commit ||
298 die "$(gettext "Cannot save the current status")"
299 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
300
301 if test -z "$patch_mode"
302 then
303 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
304 if test -n "$untracked"
305 then
306 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
307 fi
308
309 if test $# != 0
310 then
311 git reset -q -- "$@"
312 git ls-files -z --modified -- "$@" |
313 git checkout-index -z --force --stdin
314 git clean --force -q -d -- "$@"
315 else
316 git reset --hard -q
317 fi
318
319 if test "$keep_index" = "t" && test -n "$i_tree"
320 then
321 git read-tree --reset $i_tree
322 git ls-files -z --modified -- "$@" |
323 git checkout-index -z --force --stdin
324 fi
325 else
326 git apply -R < "$TMP-patch" ||
327 die "$(gettext "Cannot remove worktree changes")"
328
329 if test "$keep_index" != "t"
330 then
331 git reset -q -- "$@"
332 fi
333 fi
334}
335
336save_stash () {
337 push_options=
338 while test $# != 0
339 do
340 case "$1" in
341 --)
342 shift
343 break
344 ;;
345 -*)
346 # pass all options through to push_stash
347 push_options="$push_options $1"
348 ;;
349 *)
350 break
351 ;;
352 esac
353 shift
354 done
355
356 stash_msg="$*"
357
358 if test -z "$stash_msg"
359 then
360 push_stash $push_options
361 else
362 push_stash $push_options -m "$stash_msg"
363 fi
364}
365
366have_stash () {
367 git rev-parse --verify --quiet $ref_stash >/dev/null
368}
369
370list_stash () {
371 have_stash || return 0
372 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
373}
374
375show_stash () {
376 ALLOW_UNKNOWN_FLAGS=t
377 assert_stash_like "$@"
378
379 if test -z "$FLAGS"
380 then
381 if test "$(git config --bool stash.showStat || echo true)" = "true"
382 then
383 FLAGS=--stat
384 fi
385
386 if test "$(git config --bool stash.showPatch || echo false)" = "true"
387 then
388 FLAGS=${FLAGS}${FLAGS:+ }-p
389 fi
390
391 if test -z "$FLAGS"
392 then
393 return 0
394 fi
395 fi
396
397 git diff ${FLAGS} $b_commit $w_commit
398}
399
400show_help () {
401 exec git help stash
402 exit 1
403}
404
405#
406# Parses the remaining options looking for flags and
407# at most one revision defaulting to ${ref_stash}@{0}
408# if none found.
409#
410# Derives related tree and commit objects from the
411# revision, if one is found.
412#
413# stash records the work tree, and is a merge between the
414# base commit (first parent) and the index tree (second parent).
415#
416# REV is set to the symbolic version of the specified stash-like commit
417# IS_STASH_LIKE is non-blank if ${REV} looks like a stash
418# IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
419# s is set to the SHA1 of the stash commit
420# w_commit is set to the commit containing the working tree
421# b_commit is set to the base commit
422# i_commit is set to the commit containing the index tree
423# u_commit is set to the commit containing the untracked files tree
424# w_tree is set to the working tree
425# b_tree is set to the base tree
426# i_tree is set to the index tree
427# u_tree is set to the untracked files tree
428#
429# GIT_QUIET is set to t if -q is specified
430# INDEX_OPTION is set to --index if --index is specified.
431# FLAGS is set to the remaining flags (if allowed)
432#
433# dies if:
434# * too many revisions specified
435# * no revision is specified and there is no stash stack
436# * a revision is specified which cannot be resolve to a SHA1
437# * a non-existent stash reference is specified
438# * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
439#
440
441parse_flags_and_rev()
442{
443 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
444 PARSE_CACHE="$*"
445
446 IS_STASH_LIKE=
447 IS_STASH_REF=
448 INDEX_OPTION=
449 s=
450 w_commit=
451 b_commit=
452 i_commit=
453 u_commit=
454 w_tree=
455 b_tree=
456 i_tree=
457 u_tree=
458
459 FLAGS=
460 REV=
461 for opt
462 do
463 case "$opt" in
464 -q|--quiet)
465 GIT_QUIET=-t
466 ;;
467 --index)
468 INDEX_OPTION=--index
469 ;;
470 --help)
471 show_help
472 ;;
473 -*)
474 test "$ALLOW_UNKNOWN_FLAGS" = t ||
475 die "$(eval_gettext "unknown option: \$opt")"
476 FLAGS="${FLAGS}${FLAGS:+ }$opt"
477 ;;
478 *)
479 REV="${REV}${REV:+ }'$opt'"
480 ;;
481 esac
482 done
483
484 eval set -- $REV
485
486 case $# in
487 0)
488 have_stash || die "$(gettext "No stash entries found.")"
489 set -- ${ref_stash}@{0}
490 ;;
491 1)
492 :
493 ;;
494 *)
495 die "$(eval_gettext "Too many revisions specified: \$REV")"
496 ;;
497 esac
498
499 case "$1" in
500 *[!0-9]*)
501 :
502 ;;
503 *)
504 set -- "${ref_stash}@{$1}"
505 ;;
506 esac
507
508 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
509 reference="$1"
510 die "$(eval_gettext "\$reference is not a valid reference")"
511 }
512
513 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
514 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
515 s=$1 &&
516 w_commit=$1 &&
517 b_commit=$2 &&
518 w_tree=$3 &&
519 b_tree=$4 &&
520 i_tree=$5 &&
521 IS_STASH_LIKE=t &&
522 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
523 IS_STASH_REF=t
524
525 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
526 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
527}
528
529is_stash_like()
530{
531 parse_flags_and_rev "$@"
532 test -n "$IS_STASH_LIKE"
533}
534
535assert_stash_like() {
536 is_stash_like "$@" || {
537 args="$*"
538 die "$(eval_gettext "'\$args' is not a stash-like commit")"
539 }
540}
541
542is_stash_ref() {
543 is_stash_like "$@" && test -n "$IS_STASH_REF"
544}
545
546assert_stash_ref() {
547 is_stash_ref "$@" || {
548 args="$*"
549 die "$(eval_gettext "'\$args' is not a stash reference")"
550 }
551}
552
553apply_stash () {
554
555 assert_stash_like "$@"
556
557 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
558
559 # current index state
560 c_tree=$(git write-tree) ||
561 die "$(gettext "Cannot apply a stash in the middle of a merge")"
562
563 unstashed_index_tree=
564 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
565 test "$c_tree" != "$i_tree"
566 then
567 git diff-tree --binary $s^2^..$s^2 | git apply --cached
568 test $? -ne 0 &&
569 die "$(gettext "Conflicts in index. Try without --index.")"
570 unstashed_index_tree=$(git write-tree) ||
571 die "$(gettext "Could not save index tree")"
572 git reset
573 fi
574
575 if test -n "$u_tree"
576 then
577 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
578 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
579 rm -f "$TMPindex" ||
580 die "$(gettext "Could not restore untracked files from stash entry")"
581 fi
582
583 eval "
584 GITHEAD_$w_tree='Stashed changes' &&
585 GITHEAD_$c_tree='Updated upstream' &&
586 GITHEAD_$b_tree='Version stash was based on' &&
587 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
588 "
589
590 if test -n "$GIT_QUIET"
591 then
592 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
593 fi
594 if git merge-recursive $b_tree -- $c_tree $w_tree
595 then
596 # No conflict
597 if test -n "$unstashed_index_tree"
598 then
599 git read-tree "$unstashed_index_tree"
600 else
601 a="$TMP-added" &&
602 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
603 git read-tree --reset $c_tree &&
604 git update-index --add --stdin <"$a" ||
605 die "$(gettext "Cannot unstage modified files")"
606 rm -f "$a"
607 fi
608 squelch=
609 if test -n "$GIT_QUIET"
610 then
611 squelch='>/dev/null 2>&1'
612 fi
613 (cd "$START_DIR" && eval "git status $squelch") || :
614 else
615 # Merge conflict; keep the exit status from merge-recursive
616 status=$?
617 git rerere
618 if test -n "$INDEX_OPTION"
619 then
620 gettextln "Index was not unstashed." >&2
621 fi
622 exit $status
623 fi
624}
625
626pop_stash() {
627 assert_stash_ref "$@"
628
629 if apply_stash "$@"
630 then
631 drop_stash "$@"
632 else
633 status=$?
634 say "$(gettext "The stash entry is kept in case you need it again.")"
635 exit $status
636 fi
637}
638
639drop_stash () {
640 assert_stash_ref "$@"
641
642 git reflog delete --updateref --rewrite "${REV}" &&
643 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
644 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
645
646 # clear_stash if we just dropped the last stash entry
647 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
648 clear_stash
649}
650
651apply_to_branch () {
652 test -n "$1" || die "$(gettext "No branch name specified")"
653 branch=$1
654 shift 1
655
656 set -- --index "$@"
657 assert_stash_like "$@"
658
659 git checkout -b $branch $REV^ &&
660 apply_stash "$@" && {
661 test -z "$IS_STASH_REF" || drop_stash "$@"
662 }
663}
664
665test "$1" = "-p" && set "push" "$@"
666
667PARSE_CACHE='--not-parsed'
668# The default command is "push" if nothing but options are given
669seen_non_option=
670for opt
671do
672 case "$opt" in
673 --) break ;;
674 -*) ;;
675 *) seen_non_option=t; break ;;
676 esac
677done
678
679test -n "$seen_non_option" || set "push" "$@"
680
681# Main command set
682case "$1" in
683list)
684 shift
685 list_stash "$@"
686 ;;
687show)
688 shift
689 show_stash "$@"
690 ;;
691save)
692 shift
693 save_stash "$@"
694 ;;
695push)
696 shift
697 push_stash "$@"
698 ;;
699apply)
700 shift
701 apply_stash "$@"
702 ;;
703clear)
704 shift
705 clear_stash "$@"
706 ;;
707create)
708 shift
709 create_stash -m "$*" && echo "$w_commit"
710 ;;
711store)
712 shift
713 store_stash "$@"
714 ;;
715drop)
716 shift
717 drop_stash "$@"
718 ;;
719pop)
720 shift
721 pop_stash "$@"
722 ;;
723branch)
724 shift
725 apply_to_branch "$@"
726 ;;
727*)
728 case $# in
729 0)
730 push_stash &&
731 say "$(gettext "(To restore them type \"git stash apply\")")"
732 ;;
733 *)
734 usage
735 esac
736 ;;
737esac